#include <stdio.h>
#include <string.h>
#include "makehashstr.h"

#ifndef _WIN32
	#define stricmp strcasecmp
#endif

int main(int argc, char *argv[]) {
	if(argc < 4) {
		printf("%s <key> <steamid> <hash>\n", argv[0]);
		return(1);
	}
	
	const char * cmp;
	if(stricmp(argv[3], cmp=MakeHashStr(argv[1], argv[2]))) {
		printf(" hash  : %s\n", argv[3]);
		printf(" recalc: %s\n", cmp);
		printf("NO MATCH\n");
		return(1);
	} else {
		printf(" hash  : %s\n", argv[3]);
		printf(" recalc: %s\n", cmp);
		printf("OK\n");
		return(0);
	}
}
