#include "md5.h"
#include "aes.h"
#include <memory.h>
#include <string.h>
#include <stdio.h>

inline char* hexbyte(char * hex, unsigned char byte) {
	sprintf(hex, "%02x", (unsigned int)byte);
	return(hex);
}

const char *MakeHashStr(const char *key, const char *str) {
	static char str_output[128];
	char hex[32];
	
	unsigned int i, j, k;
	uint8 input[16];
	uint8 output[16];
	uint8 aeskey[32];
	md5_context md5cnx;
	aes_context aescnx;
	
	memset(aeskey,0,sizeof(aeskey));
	memset(input,0,sizeof(input));
	memset(output,0,sizeof(input));
	memset(&md5cnx,0,sizeof(md5cnx));
	memset(&aescnx,0,sizeof(aescnx));
	
	for(i = 0, j = 0, k = strlen(key); i < sizeof(aeskey); i++) {
		if(j == k)
			j = 0;
		aeskey[i] = key[j++];
	}
	
	md5_starts(&md5cnx);
	md5_update(&md5cnx, (uint8 *)str, strlen(str));
	md5_finish(&md5cnx, input);
	
	aes_set_key(&aescnx, aeskey, 256);
	aes_encrypt(&aescnx, input, output);
	
	str_output[0]=0;
	for(i = 0; i < sizeof(output); i++) {
		strcat(str_output, hexbyte(hex, output[i]));
	}
	
	return(str_output);
}
